/* Simplistic Acceleration Sensor for AIBO robots
 * by Marco Zaratti - marco.zaratti@gmail.com
*/
class AccelerationSensor extends Sensor config (USARBot);

var vector lastVelocity;
var float lastTime;

function String GetData()
{
    local string outstring;
	local vector vel;
	local float time;
	local vector accel;

	vel = platform.Velocity;
	time = Level.TimeSeconds;

	accel = (vel - lastVelocity) / (time - lastTime);
	accel = accel << platform.Rotation;

	lastVelocity = vel;
	lastTime = time;
	if(converter != none)
        accel = converter.VelocityVectorFromUU(accel);

    outstring="{Name "$ItemName$"} {Acceleration "$accel.X$","$accel.Y$","$accel.Z$"}";

	return outstring;
}

defaultproperties
{
	ItemType="Accel"
}
