class USARDeathMatch extends BotDeathMatch config(USARBot);

var array<USARVictim> Victims;
var array<KVehicle> Vehicles;
var array<RFIDTag> RFIDTags;
var array<SEERPawn> SeerVictims;
var array<VictRFIDTag> VictRFIDTags;
var int SSTagsId; // SingleShotTags count
var int MSTagsId; // MultiShotTags count
var config bool bAutoId;
var config bool bstats;
var FileLog TagLog;
var FileLog AdminLog;
var Soccerball KBall;

var int WheelCount; //General purpose counter controlled by mouse wheel

function PostNetBeginPlay()
{
	Super.PostNetBeginPlay();

    if(Role == ROLE_Authority)
    	foreach AllActors(class'SoccerBall',KBall) break;
}

exec function MB(optional int posX, optional int posY)
{
    if(KBall != none)
    {
        KBall.MoveBall(posX,posY,10);
    }
}

/* Create ball console command
exec function CB(optional int posX, optional int posY)
{
    local vector pos;
    pos.X = posX;
    pos.Y = posY;
    pos.Z = 10;
    Spawn(class'USARBot.SoccerBall',,,pos);
}*/

exec function KB(String direction, optional float force)
{
    if(KBall != none)
    {
        KBall.KickBall(direction, force);
    }
}

function actor GetRobot(String name) {
	local string botName;
	local int i;

	for (i=0;i<Vehicles.length;i++) {
		botName = Vehicles[i].Controller.PlayerReplicationInfo.PlayerName;
		if (botName==name)
			return Vehicles[i];
	}
	return None;
}

//We dont want UT bots running around the map!
function bool NeedPlayers()
{
	return False;
}

defaultproperties
{
    BotServerClass=USARBotServer
    RemoteBotClass=USARRemoteBot
    GameName="USARSim Simulation"
    PlayerControllerClassName="USARBot.ViewTestPlayerController"
    HUDType="USARBot.USARHUD"
    bAllowVehicles=True
    GameReplicationInfoClass=Class'USARReplicationInfo'
	bAutoId=true
	bstats=true
	TimeLimit=0
	SSTagsId=1000
}
