class USARRemoteBot extends RemoteBot;

//CAMERA parameters
var rotator	myCameraRotation;
var byte	myCameraRotationOrder;
var float	myCameraZoom;

//DRIVE middle level parameters
var float	LeftThrottle;    //Used for skid-steered robots
var float	RightThrottle;   //Used for skid-steered robots
var float   Speed;           //Used for Ackerman-steered robots
var float   FrontSteer;      //Used for Ackerman-steered robots
var float   RearSteer;       //Used for Ackerman-steered robots
var bool	Normalized;      //Used for all robots
var bool	bNewThrottle;    //Used for all robots

//DRIVE low level parameters
var byte	JointControlIdx;
var array<string>	JName;
var array<float>	JSteer;
var array<byte> 	JOrder;
var array<float>	JValue;
//DRIVE auxiliary parameters
var bool	Light;
var bool	Flip;

//Turn parameters (obsolete)
var rotator	myTurn;
var float	myDistance;

//GETGEO parameters
var string  GeoType;
var string  GeoName;

//FETCONF parameters
var string  ConfType;
var string  ConfName;

//SET parameters
var string  SetType;
var string	SetName;
var String  OpCode;
var String  Params;

var bool	RangeScan;
var bool	IRCameraScan;
var bool	SetPosition, SetOrientation, SetEncoder;

//MISPKG parameters
var string  MPName;
var rotator MPRotation;
var vector  MPTranslation;
var byte    MPOrder;

//Needed for the gripper
var bool bGrip;

// The name of the robot
var string RobotName;

//This function is called by USARBotConnection. The latter
//can't call directly KRobot Pawn (at least it seems so) that's
//why we need a "bridge" function.
function SetSkin(string skinName)
{
    KRobot(Pawn).SetSkin(skinName);
}

defaultproperties
{
    DrawScale=0.0001
    bSilentGamebot=True
}
