class ViewTestPlayerController extends xPlayer
	config(USARBot);

var byte mode;
var byte oldDuck;

var actor rRobot, myRobot, lastRobot;
var String myIP, rIP, rCameraName, rRobotName;
var RobotCamera rCamera;
var vector rCamLoc, myCamLoc;
var rotator rCamRot, myCamRot;
var int rCamFov, myCamFov;
var USARReplicationInfo gInfo;

replication {
    reliable if( Role<ROLE_Authority ) ServerCheck;
	reliable if( Role==ROLE_Authority ) rIP, rRobot, rCamLoc, rCamRot, rCamFov;
}

simulated event PostBeginPlay() {
	local InternetLink dummyLink;
	local InternetLink.IpAddr ip;

    Super.PostBeginPlay();

   	if (Role==ROLE_Authority)
   		gInfo = USARReplicationInfo(Level.Game.GameReplicationInfo);
   	dummyLink = spawn(class'IpDrv.InternetLink');
    dummyLink.GetLocalIP(ip);
    myIp = dummyLink.IpAddrToString(ip);
    myIp = Left(myIP,Len(myIp)-2);
    log("MyIP="$myIP);
}

function ServerCheck() {
	if (gInfo==None)
		gInfo = USARReplicationInfo(Level.Game.GameReplicationInfo);

	if (gInfo!=None && (rRobotName!=gInfo.cltRobot||rIP!=gInfo.cltIP||rCameraName!=gInfo.cltCamera)) {
		rRobot = USARDeathMatch(Level.Game).getRobot(gInfo.cltRobot);
		if (KRobot(rRobot)!=None)
			rCamera = KRobot(rRobot).getCamera(gInfo.cltCamera);
		rRobotName = gInfo.cltRobot;
   		rIP = gInfo.cltIP;
   		rCameraName = gInfo.cltCamera;
   	}
   	if (rCamera!=None) {
		rCamLoc = rCamera.Location;
		rCamRot = rCamera.Rotation;
		rCamFov = rCamera.CameraFov;
   	}
}

function PlayerTick(float Delta) {
    Super.PlayerTick(Delta);

    ServerCheck();
    if (myIP==rIP) {
    	myRobot = rRobot;
    	myCamLoc = rCamLoc;
    	myCamRot = rCamRot;
    	myCamFov = rCamFov;
    }
}

function event PlayerCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation )
{
  local MultiView MV;
  if (Pawn!=None && !Pawn.IsA('KVehicle')) {
  	Super.PlayerCalcView(ViewActor,CameraLocation,CameraRotation);
  	return;
  }

  if (lastRobot!=None || myRobot!=None)
  	SetViewTarget(myRobot);
  lastRobot = myRobot;
  if ( (ViewTarget == None) || ViewTarget.bDeleteMe ) {
	if ( (Pawn != None) && !Pawn.bDeleteMe ) SetViewTarget(Pawn);
	else SetViewTarget(self);
  }
  if (oldDuck==0&&bDuck==1) mode=mode+1;
  if (mode>2) mode=1;
  oldDuck=bDuck;

  ViewActor = ViewTarget;               // Set the output variable ViewActor with the new view target
  FovAngle = default.FovAngle;
  if (ViewTarget.IsA('USARCar')) {
  	if (USARCar(ViewTarget).Headlight!=None) {
		CameraLocation = USARCar(ViewTarget).Headlight.Location;
		if (mode==2) CameraLocation.Z += 80;
    	CameraRotation = USARCar(ViewTarget).Headlight.Rotation;
    	if (mode==2) {
    		CameraRotation.pitch=-16384;
    		CameraRotation.roll=0;
    	}
    	FovAngle = USARCar(ViewTarget).CameraZoom;
    }
  }
  else if (ViewTarget.IsA('USARBc')) {
  	if (USARBc(ViewTarget).Headlight!=None) {
		CameraLocation = USARBc(ViewTarget).Headlight.Location;
		if (mode==2) CameraLocation.Z += 80;
    	CameraRotation = USARBc(ViewTarget).Headlight.Rotation;
    	if (mode==2) {
    		CameraRotation.pitch=-16384;
    		CameraRotation.roll=0;
    	}
    	FovAngle = USARBc(ViewTarget).CameraZoom;
    }
  }
  else if (ViewTarget.IsA('USARRobot')) {
  	if (USARRobot(ViewTarget).Headlight!=None) {
		CameraLocation = USARRobot(ViewTarget).Headlight.Location;
    	CameraRotation = USARRobot(ViewTarget).Headlight.Rotation;
    	FovAngle = USARRobot(ViewTarget).CameraZoom;
    }
  }
  else if (ViewTarget.IsA('KRobot')) {
  	if (KRobot(ViewTarget).myCamera==None) {
  		myCamFov = 1;
  	} else if (myRobot==None && KRobot(ViewTarget).myCamera!=None) {
  		myCamLoc = KRobot(ViewTarget).myCamera.Location;
  		myCamRot = KRobot(ViewTarget).myCamera.Rotation;
  		myCamFov = KRobot(ViewTarget).CameraZoom;
  	}
	CameraLocation = myCamLoc;
	if (mode==2) CameraLocation.Z += 80;
    CameraRotation = myCamRot;
   	if (mode==2) {
   		CameraRotation.pitch=-16384;
   		CameraRotation.roll=0;
   	}
   	FovAngle = myCamFov;
  }
  else if (ViewTarget.IsA('MultiView'))
  {
    MV = MultiView(ViewTarget);
    if(MV.IsCameraLocked)
    {
    	CameraLocation = MV.Location;
    	CameraRotation = MV.Rotation;
    	FovAngle = MV.CameraZoom;
    }
  }
}

exec function PrevWeapon()
{
    super.PrevWeapon();
    USARDeathMatch(Level.Game).WheelCount--;
}

exec function NextWeapon()
{
    super.NextWeapon();
    USARDeathMatch(Level.Game).WheelCount++;
}

defaultproperties
{
	mode=1
	FovAngle=90
}
